Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing
Class UIManager

    java.lang.Object
      |
      +--javax.swing.UIManager

public class UIManager
extends java.lang.Object
implements java.io.Serializable

This class keeps track of the current look and feel and its defaults.

We manage three levels of defaults: user defaults, look and feel defaults, system defaults. A call to UIManager.get() checks all three levels in order and returns the first non-null value for a key, if any. A call to UIManager.put() just affects the user defaults. Note that a call to setLookAndFeel() doesn't affect the user defaults, it just replaces the middle defaults "level".

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. A future release of Swing will provide support for long term persistence.

See Also:
  Serialized Form

Inner Class Summary
`static class` | `UIManager.LookAndFeelInfo` Provide a little information about an installed LookAndFeel for the sake of configuring a menu or for initial application set up.

Constructor Summary
`UIManager()`

Method Summary
`static void` | `addAuxiliaryLookAndFeel(LookAndFeel laf)` Add a LookAndFeel to the list of auxiliary look and feels.
`static void` | `addPropertyChangeListener(java.beans.PropertyChangeListener listener)` Add a PropertyChangeListener to the listener list.
`static java.lang.Object` | `get(java.lang.Object key)` Returns an object from the defaults table.
`static LookAndFeel[]` | `getAuxiliaryLookAndFeels()` Return the list of auxiliary look and feels (can be null).
`static Border` | `getBorder(java.lang.Object key)` Returns a border from the defaults table.
`static java.awt.Color` | `getColor(java.lang.Object key)` Returns a drawing color from the defaults table.
`static java.lang.String` | `getCrossPlatformLookAndFeelClassName()` Returns the name of the LookAndFeel class that implements the default cross platform look and feel, i.e.
`static UIDefaults` | `getDefaults()` Returns the default values for this look and feel.
`static java.awt.Dimension` | `getDimension(java.lang.Object key)` Returns a dimension from the defaults table.
`static java.awt.Font` | `getFont(java.lang.Object key)` Returns a drawing font from the defaults table.
`static Icon` | `getIcon(java.lang.Object key)` Returns an Icon from the defaults table.
`static java.awt.Insets` | `getInsets(java.lang.Object key)` Returns an Insets object from the defaults table.
`static UIManager.LookAndFeelInfo[]` | `getInstalledLookAndFeels()` Return an array of objects that provide some information about the LookAndFeel implementations that have been installed with this java development kit.
`static int` | `getInt(java.lang.Object key)` Returns an int from the defaults table.
`static LookAndFeel` | `getLookAndFeel()` Returns The current default look and feel, or null.
`static UIDefaults` | `getLookAndFeelDefaults()` Returns the default values for this look and feel.
`static java.lang.String` | `getString(java.lang.Object key)` Returns a string from the defaults table.
`static java.lang.String` | `getSystemLookAndFeelClassName()` Returns the name of the LookAndFeel class that implements the native systems look and feel if there is one, otherwise the name of the default cross platform LookAndFeel class.
`static ComponentUI` | `getUI(JComponent target)` Returns the L&F object that renders the target component.
`static void` | `installLookAndFeel(java.lang.String name, java.lang.String className)` Creates a new look and feel and adds it to the current array.
`static void` | `installLookAndFeel(UIManager.LookAndFeelInfo info)` Adds the specified look and feel to the current array and then calls `setInstalledLookAndFeels(javax.swing.UIManager.LookAndFeelInfo[])`.
`static java.lang.Object` | `put(java.lang.Object key, java.lang.Object value)` Stores an object in the defaults table.
`static boolean` | `removeAuxiliaryLookAndFeel(LookAndFeel laf)` Remove a LookAndFeel from the list of auxiliary look and feels.
`static void` | `removePropertyChangeListener(java.beans.PropertyChangeListener listener)` Remove a PropertyChangeListener from the listener list.
`static void` | `setInstalledLookAndFeels(UIManager.LookAndFeelInfo[] infos)` Replaces the current array of installed LookAndFeelInfos.
`static void` | `setLookAndFeel(LookAndFeel newLookAndFeel)` Set the current default look and feel using a LookAndFeel object.
`static void` | `setLookAndFeel(java.lang.String className)` Set the current default look and feel using a class name.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### UIManager

    public UIManager()

Method Detail

### getInstalledLookAndFeels

    public static UIManager.LookAndFeelInfo[] getInstalledLookAndFeels()

  Return an array of objects that provide some information about the LookAndFeel implementations that have been installed with this java development kit. The LookAndFeel info objects can be used by an application to construct a menu of look and feel options for the user or to set the look and feel at start up time. Note that we do not return the LookAndFeel classes themselves here to avoid the cost of unnecessarily loading them.

  Given a LookAndFeelInfo object one can set the current look and feel like this:

       UIManager.setLookAndFeel(info.getClassName());

  See Also:
    `setLookAndFeel(javax.swing.LookAndFeel)`

### setInstalledLookAndFeels

    public static void setInstalledLookAndFeels(UIManager.LookAndFeelInfo[] infos)
                                         throws java.lang.SecurityException

  Replaces the current array of installed LookAndFeelInfos.
  See Also:
    `getInstalledLookAndFeels()`

### installLookAndFeel

    public static void installLookAndFeel(UIManager.LookAndFeelInfo info)

  Adds the specified look and feel to the current array and then calls `setInstalledLookAndFeels(javax.swing.UIManager.LookAndFeelInfo[])`.
  Parameters:
    `info` - a LookAndFeelInfo object that names the look and feel and identifies that class that implements it

### installLookAndFeel

    public static void installLookAndFeel(java.lang.String name,
                                          java.lang.String className)

  Creates a new look and feel and adds it to the current array. Then calls `setInstalledLookAndFeels(javax.swing.UIManager.LookAndFeelInfo[])`.
  Parameters:
    `name` - a String specifying the name of the look and feel
    `className` - a String specifying the class name that implements the look and feel

### getLookAndFeel

    public static LookAndFeel getLookAndFeel()

  Returns The current default look and feel, or null.
  Returns:
    The current default look and feel, or null.
  See Also:
    `setLookAndFeel(javax.swing.LookAndFeel)`

### setLookAndFeel

    public static void setLookAndFeel(LookAndFeel newLookAndFeel)
                               throws UnsupportedLookAndFeelException

  Set the current default look and feel using a LookAndFeel object.

  This is a JavaBeans bound property.

  Parameters:
    `newLookAndFeel` - the LookAndFeel object
  Throws:
    UnsupportedLookAndFeelException - If `lnf.isSupportedLookAndFeel()` is false.
  See Also:
    `getLookAndFeel()`

### setLookAndFeel

    public static void setLookAndFeel(java.lang.String className)
                               throws java.lang.ClassNotFoundException,
                                      java.lang.InstantiationException,
                                      java.lang.IllegalAccessException,
                                      UnsupportedLookAndFeelException

  Set the current default look and feel using a class name.
  Parameters:
    `className` - a string specifying the name of the class that implements the look and feel
  Throws:
    java.lang.ClassNotFoundException - If the LookAndFeel class could not be found.
    java.lang.InstantiationException - If a new instance of the class couldn't be creatd.
    java.lang.IllegalAccessException - If the class or initializer isn't accessible.
    UnsupportedLookAndFeelException - If `lnf.isSupportedLookAndFeel()` is false.

### getSystemLookAndFeelClassName

    public static java.lang.String getSystemLookAndFeelClassName()

  Returns the name of the LookAndFeel class that implements the native systems look and feel if there is one, otherwise the name of the default cross platform LookAndFeel class.
  See Also:
    `setLookAndFeel(javax.swing.LookAndFeel)`, `getCrossPlatformLookAndFeelClassName()`

### getCrossPlatformLookAndFeelClassName

    public static java.lang.String getCrossPlatformLookAndFeelClassName()

  Returns the name of the LookAndFeel class that implements the default cross platform look and feel, i.e. the "Java Look and Feel", or JLF.
  Returns:
    a string with the JLF implementation-class
  See Also:
    `setLookAndFeel(javax.swing.LookAndFeel)`, `getSystemLookAndFeelClassName()`

### getDefaults

    public static UIDefaults getDefaults()

  Returns the default values for this look and feel.
  Returns:
    an UIDefaults object containing the default values

### getFont

    public static java.awt.Font getFont(java.lang.Object key)

  Returns a drawing font from the defaults table.
  Parameters:
    `key` - an Object specifying the font
  Returns:
    the Font object

### getColor

    public static java.awt.Color getColor(java.lang.Object key)

  Returns a drawing color from the defaults table.
  Parameters:
    `key` - an Object specifying the color
  Returns:
    the Color object

### getIcon

    public static Icon getIcon(java.lang.Object key)

  Returns an Icon from the defaults table.
  Parameters:
    `key` - an Object specifying the icon
  Returns:
    the Icon object

### getBorder

    public static Border getBorder(java.lang.Object key)

  Returns a border from the defaults table.
  Parameters:
    `key` - an Object specifying the border
  Returns:
    the Border object

### getString

    public static java.lang.String getString(java.lang.Object key)

  Returns a string from the defaults table.
  Parameters:
    `key` - an Object specifying the string
  Returns:
    the String

### getInt

    public static int getInt(java.lang.Object key)

  Returns an int from the defaults table.
  Parameters:
    `key` - an Object specifying the int
  Returns:
    the int

### getInsets

    public static java.awt.Insets getInsets(java.lang.Object key)

  Returns an Insets object from the defaults table.
  Parameters:
    `key` - an Object specifying the Insets object
  Returns:
    the Insets object

### getDimension

    public static java.awt.Dimension getDimension(java.lang.Object key)

  Returns a dimension from the defaults table.
  Parameters:
    `key` - an Object specifying the dimension object
  Returns:
    the Dimension object

### get

    public static java.lang.Object get(java.lang.Object key)

  Returns an object from the defaults table.
  Parameters:
    `key` - an Object specifying the desired object
  Returns:
    the Object

### put

    public static java.lang.Object put(java.lang.Object key,
                                       java.lang.Object value)

  Stores an object in the defaults table.
  Parameters:
    `key` - an Object specifying the retrieval key
    `value` - the Object to store
  Returns:
    the Object returned by `UIDefaults.put`

### getUI

    public static ComponentUI getUI(JComponent target)

  Returns the L&F object that renders the target component.
  Parameters:
    `target` - the JComponent to render
  Returns:
    the ComponentUI object that renders the target component

### getLookAndFeelDefaults

    public static UIDefaults getLookAndFeelDefaults()

  Returns the default values for this look and feel.
  Returns:
    an UIDefaults object containing the default values

### addAuxiliaryLookAndFeel

    public static void addAuxiliaryLookAndFeel(LookAndFeel laf)

  Add a LookAndFeel to the list of auxiliary look and feels. The auxiliary look and feels tell the multiplexing look and feel what other LookAndFeel classes for a component instance are to be used in addition to the default LookAndFeel class when creating a multiplexing UI. The change will only take effect when a new UI class is created or when the default look and feel is changed on a component instance.

  Note these are not the same as the installed look and feels.

  Parameters:
    `laf` - the LookAndFeel object
  See Also:
    `removeAuxiliaryLookAndFeel(javax.swing.LookAndFeel)`, `setLookAndFeel(javax.swing.LookAndFeel)`, `getAuxiliaryLookAndFeels()`, `getInstalledLookAndFeels()`

### removeAuxiliaryLookAndFeel

    public static boolean removeAuxiliaryLookAndFeel(LookAndFeel laf)

  Remove a LookAndFeel from the list of auxiliary look and feels. The auxiliary look and feels tell the multiplexing look and feel what other LookAndFeel classes for a component instance are to be used in addition to the default LookAndFeel class when creating a multiplexing UI. The change will only take effect when a new UI class is created or when the default look and feel is changed on a component instance.

  Note these are not the same as the installed look and feels.

  Returns:
    true if the LookAndFeel was removed from the list
  See Also:
    `removeAuxiliaryLookAndFeel(javax.swing.LookAndFeel)`, `getAuxiliaryLookAndFeels()`, `setLookAndFeel(javax.swing.LookAndFeel)`, `getInstalledLookAndFeels()`

### getAuxiliaryLookAndFeels

    public static LookAndFeel[] getAuxiliaryLookAndFeels()

  Return the list of auxiliary look and feels (can be null). The auxiliary look and feels tell the multiplexing look and feel what other LookAndFeel classes for a component instance are to be used in addition to the default LookAndFeel class when creating a multiplexing UI.

  Note these are not the same as the installed look and feels.

  See Also:
    `addAuxiliaryLookAndFeel(javax.swing.LookAndFeel)`, `removeAuxiliaryLookAndFeel(javax.swing.LookAndFeel)`, `setLookAndFeel(javax.swing.LookAndFeel)`, `getInstalledLookAndFeels()`

### addPropertyChangeListener

    public static void addPropertyChangeListener(java.beans.PropertyChangeListener listener)

  Add a PropertyChangeListener to the listener list. The listener is registered for all properties.
  Parameters:
    `listener` - The PropertyChangeListener to be added
  See Also:
    `PropertyChangeSupport`

### removePropertyChangeListener

    public static void removePropertyChangeListener(java.beans.PropertyChangeListener listener)

  Remove a PropertyChangeListener from the listener list. This removes a PropertyChangeListener that was registered for all properties.
  Parameters:
    `listener` - The PropertyChangeListener to be removed
  See Also:
    `PropertyChangeSupport`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-1998 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.